package com.codegeist.fisheye.domain;

import java.util.Date;

/**
 * <pre>
 * struct Changeset {
 *  String csid; // (REST: attribute)
 *  Date date; // (REST: attribute)
 *  String author; // (REST: attribute)
 *  String branch; // (REST: attribute)
 *  boolean sealed; // (REST: attribute)
 *  String log;
 *  RevisionKey[] revisions;
 * }
 * </pre>
 * 
 * @author Brock Janiczak
 */
public class Changeset {
	private final String changesetId;
	private final Date date;
	private final String author;
	private final String branch;
	private final boolean sealed;
	private final String log;
	private final RevisionKey[] revisions;
	
	public Changeset(String changesetId, Date date, String author, String branch, boolean sealed, String log, RevisionKey[] revisions) {
		this.changesetId = changesetId;
		this.date = date;
		this.author = author;
		this.branch = branch;
		this.sealed = sealed;
		this.log = log;
		this.revisions = revisions;
	}

	public String getChangesetId() {
		return changesetId;
	}

	public Date getDate() {
		return date;
	}

	public String getAuthor() {
		return author;
	}

	public String getBranch() {
		return branch;
	}

	public boolean isSealed() {
		return sealed;
	}

	public String getLog() {
		return log;
	}

	public RevisionKey[] getRevisions() {
		return revisions;
	}
	
	@Override
	public String toString() {
		StringBuilder sb = new StringBuilder();
		
		sb.append(changesetId);
		sb.append(" [");
		sb.append(author).append(" ");
		sb.append(date);
		sb.append("]");
		
		return sb.toString();
	}

}
