package com.codegeist.fisheye.domain.query;

public class BranchChangeRestriction implements Restriction {
	
	private final String branch;
	private final Operation operation;

	public BranchChangeRestriction(String branch) {
		this(branch, null);
	}
	
	public BranchChangeRestriction(String branch, Operation operation) {
		this.branch = branch;
		this.operation = operation;
	}
	
	public StringBuilder appendEyeQlFragment(StringBuilder buffer) {
		if (operation != null) {
			buffer.append(" ");
			buffer.append(operation.getEyeQl());
		}
		buffer.append(" on branch ");
		buffer.append(branch);
		
		return buffer;
	}
	
	public enum Operation {
		MODIFIED("modified"),
		ADDED("added"),
		DELETED("deleted");
		
		private final String eyeql;

		Operation(String eyeql) {
			this.eyeql = eyeql;
			
		}
		
		public String getEyeQl() {
			return eyeql;
		}
	}
}
