package com.codegeist.fisheye.domain.query;

import com.codegeist.fisheye.domain.RevisionKey;
import com.codegeist.fisheye.domain.query.Query.ReturnValue;

/**
 * Interface for receiving notifications of query matches.  The callback method that will be called
 * from the query will depend on the type of query being processed.  If the query contains no return
 * value {@link #matchRevisionKey} will be called, else {@link #matchData} will be called.
 * 
 * @author Brock Janiczak
 */
public interface IQueryMatchListener {

	void matchRevisionKey(RevisionKey revisionKey);
	
	void matchData(ReturnValue[] columns, Object[] values);
}
