package com.codegeist.fisheye.internal.service;

import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;

public class StringRegistry {
	private static Map<String, String> branchPool = new ConcurrentHashMap<String, String>();
	private static Map<String, String> csidPool = new ConcurrentHashMap<String, String>();
	private static Map<String, String> pathPool = new ConcurrentHashMap<String, String>();
	private static Map<String, String> revPool = new ConcurrentHashMap<String, String>();
	private static Map<String, String> authorPool = new ConcurrentHashMap<String, String>();
	private static int stringsSaved = 0;
	private static int bytesSaved = 0;
	
	
	private StringRegistry() {
	}
	
	public static String internBranch(String branch) {
		return intern(branchPool, branch);
	}
	
	public static String internChangeSetId(String csid) {
		return intern(csidPool, csid);
	}
	
	public static String internPath(String path) {
		return intern(pathPool, path);
	}
	
	public static String internRev(String rev) {
		return intern(revPool, rev);
	}
	
	public static String internAuthor(String author) {
		return intern(authorPool, author);
	}
	
	static String intern(Map<String, String> pool, String value) {
		if (value == null) {
			return null;
		}
		
		String internedValue = pool.get(value);
		if (internedValue == null) {
			internedValue = value;
			pool.put(internedValue, internedValue);
		} else {
			if (internedValue != value) {
				stringsSaved++;
				bytesSaved += 44 + 2 * value.length();
			}
		}
		return internedValue;
	}
}
