package com.codegeist.fisheye.internal.ui.handlers;

import org.eclipse.core.commands.AbstractHandler;
import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.core.commands.ExecutionException;
import org.eclipse.core.resources.IResource;
import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.team.ui.TeamUI;
import org.eclipse.ui.PlatformUI;
import org.eclipse.ui.handlers.HandlerUtil;

import com.codegeist.fisheye.internal.ui.history.FisheyeHistoryPageSource;

public class ShowHistoryHandler extends AbstractHandler {

	public Object execute(ExecutionEvent event) throws ExecutionException {
		ISelection currentSelection = HandlerUtil.getCurrentSelection(event);
		if (currentSelection instanceof IStructuredSelection) {
			Object selection = ((IStructuredSelection) currentSelection).getFirstElement();
			IResource resource = null;
			if (selection instanceof IResource) {
				resource = (IResource) selection;
			} else if (selection instanceof IAdaptable) {
				resource = (IResource) ((IAdaptable) selection).getAdapter(IResource.class);
			}
			
			if (resource != null) {
				TeamUI.showHistoryFor(PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage(), selection, new FisheyeHistoryPageSource());
				return null;
			}
		}
		
		return null;
	}


}
